#pragma once

#include "AnalysisPass.hpp"
#include "Function.hpp"
#include "LoopDetection.hpp"
#include "Module.hpp"
#include "PassManager.hpp"

using namespace std;

class LoopSimplify : public Pass<Function> {
  public:
    using IRUnit = Module;
    using PhiPair = pair<Value *, BasicBlock *>;
    void run(Function *func, AnalysisPassManager &APM);

  private:
    pair<vector<PhiPair>, vector<PhiPair>> split_phi_op(PhiInst *phi,
                                                        Loop &loop);
    BasicBlock *preheader_insertion(Loop &loop);
    void exit_insertion(BasicBlock *exiting, BasicBlock *outer_bb);
};
